import { RaamCSS, RaamStyleProps, WithIndex, WithRaamTheme } from "@raam/core";
declare type FlexboxVariants = "hStack" | "vStack" | "wrap";
declare type ParentStyleProps = "alignItems" | "alignContent" | "flexDirection" | "flexWrap" | "gap" | "justifyContent" | "justifyItems";
interface ParentProps extends WithRaamTheme, Pick<RaamStyleProps, ParentStyleProps> {
    withoutBaseStyles?: boolean;
    withoutElementStyles?: boolean;
}
declare type ChildStyleProps = "flex" | "flexGrow" | "flexBasis" | "flexShrink";
interface ChildProps extends WithIndex, ParentProps, Pick<RaamStyleProps, ChildStyleProps> {
    withoutMarginStyles?: boolean;
    withoutFlexStyles?: boolean;
}
export interface FlexboxProps extends ParentProps, WithRaamTheme {
    variant?: FlexboxVariants;
}
export interface FlexboxChildProps extends Pick<ChildProps, "index" | ChildStyleProps> {
}
export interface FlexboxChildOwnProps extends Omit<ChildProps, "theme"> {
}
export declare type FlexboxStylePropsKeys = ChildStyleProps | ParentStyleProps;
export interface FlexboxStyleProps extends Pick<RaamStyleProps, FlexboxStylePropsKeys> {
}
export declare const flexbox: (props?: FlexboxProps) => {
    parent: () => RaamCSS;
    child: (childProps?: FlexboxChildOwnProps) => RaamCSS;
};
export {};
